# by plushpuffin@wwddfd.com
# http://www.wwddfd.com
# Cyndi Lauper
#
&CheckBuild(28, "Cyndi Lauper", "npa_cyndilauper.pl");
push(@Addons_Loaded, 'Cyndi Lauper 1.1');
push(@Addons_PageHandler, 'CyndiLauperPageHandler');
push(@Addons_MainPage, 'CyndiLauper_MainPage');
push(@Addons_NPHTMLFoot, 'CyndiLauper_HTMLFoot');
unshift(@Addons_SaveNews, 'CyndiLauperSaveNews' );
push(@Addons_RemoveNews, 'CyndiLauperGetReady' );
push(@Addons_RemoveNewsSave, 'CyndiLauperRemoveNewsSave' );
$Addons_List{'Cyndi Lauper 1.1'} = ['npa_cyndilauper.pl', 'Escape HTML in specific parts of your fields using &lt;esc&gt; tags. by <a href="mailto:plushpuffin@wwddfd.com">plushpuffin</a>'];

sub CyndiLauperPageHandler {
	if (query_string() =~ /^cyndilauper/i) {
		&CyndiLauperMain;
	}
}

sub CyndiLauper_HTMLFoot {
	if ($up == 3) {
		print qq~ <a href="$scripturl?cyndilauper" class="navlink">Cyndi Lauper</a> |~;
	}
}

sub CyndiLauper_MainPage {
	if ($up == 3) {
		print qq~
		<b><a href="$scripturl?cyndilauper">Cyndi Lauper</a>:</b> When I think about you...<br><br>
		~;
	}
}

sub CyndiLauperSaveNews {
	my( $i, @cfselect );
	@cfselect = split( /\|x\|/, $NPConfig{'CLFSelect'} );
	foreach $i (@cfselect) {
		${$i} =~ s~<esc>(.*?)</esc>~'<esc>' . HTMLeskape($1) . '</esc>'~ige;
	}
}

sub CyndiLauperGetReady {
	@cfselect = split( /\|x\|/, $NPConfig{'CLFSelect'} );
	unshift(@Addons_RemoveNews2, 'CyndiLauperRemoveNews2');
}

sub HTMLeskape {
	my $text = shift;
	$text =~ s/&/&amp;/g;
	$text =~ s/</&lt;/g;
	$text =~ s/>/&gt;/g;
	$text =~ s/"/&quot;/g;
	$text =~ s/&lt;br&gt;/<br>/gi;
	return $text;
}

sub HTMLimprison {
	my $text = shift;
	$text =~ s/&amp;/&/g;
	$text =~ s/&lt;/</g;
	$text =~ s/&gt;/>/g;
	$text =~ s/&quot;/"/g;
	return $text;
}

sub CyndiLauperRemoveNews2 {
	my( $i, $chknum );
	foreach $i (@cfselect) {
		${$i} =~ s~<esc>(.*?)</esc>~'<esc>' . HTMLimprison($1) . '</esc>'~ige;
	}
}

sub CyndiLauperRemoveNewsSave {
	my( $i, $nn, $chknum, @cfselect );
	@cfselect = split( /\|x\|/, $NPConfig{'CLFSelect'} );
	foreach $i (@cfselect) {
		for( $nn = 0; $nn < $totnewsnum; $nn++ ) {
			$chknum = "chk--$nn";
			if ($in{$chknum} ne 'remove' && $in{$chknum} eq 'keep' ) {
				$in{"$i--$nn"} =~ s~<esc>(.*?)</esc>~'<esc>' . HTMLeskape($1) . '</esc>'~ige;
			}
		}
	}
}

sub CyndiLauperMain {
	unless( $up > 2 ) { &NPdie('You are not allowed to access this.') }
	if( $in{'CyndiLaupersaveset'} ) {
		# save settings
		&NPHTMLHead("Cyndi Lauper Save Settings");
		print qq~
		<div align="center">~;
		if( $in{'CLFSelect'} ) {
			$NPConfig{'CLFSelect'} = $in{'CLFSelect'};
			&WriteConfigInfo;
			print q~
			Settings for Cyndi Lauper have been saved.<BR>
			~;
		}
		print qq~
		<h3><a href="$scripturl">back to newspro</a><BR>
		<a href="$scripturl?cyndilauper">back to CyndiLauper</a></h3>
		~;
	}
	elsif( $in{'CyndiLauperset'} || query_string() eq 'cyndilauper') {
		# display edit settings
		&NPHTMLHead("Cyndi Lauper Edit Settings");
		print qq~
		<form action="$scripturl?cyndilauper" method="POST">
		<table cellspacing="5" cellpadding="10" align="center">
		~;
		&SubmitFormFields;
		my @selectedfields = split(/\|x\|/, $NPConfig{'CLFSelect'} );
		my %selectedfields;
		push( @formfields, 'newstext' );
		foreach $i (@selectedfields) {
			$selectedfields{$i} = 'selected';
		}
		$i = $#formfields + 2;
		print qq~<tr><td valign="middle"><font size="+1">Select individual fields to run &lt;esc&gt; on:<BR>
		Please note that &lt;BR&gt; tags are exempt from the &lt;esc&gt; effect.<BR><BR>
		<center>by <a href="mailto:plushpuffin\@wwddfd.com">plushpuffin</a><BR>
		<a href="http://www.wwddfd.com">plushpuffin's perl garden</a></center>
		</font>
		</td><td>
		<select name="CLFSelect" size="$i" multiple>
		<option value="(nil)" $selectedfields{'nil'}>(nothing selected)</option>
		~;
		foreach $i (@formfields) {
			print qq~
			<option value="$i" $selectedfields{$i}>$i</option>~;
		}
		print qq~
		</select>
		~;
		print qq~
		</tr><tr><td colspan="9" align="center">
		<input type="submit" name="CyndiLaupersaveset" value="Save Cyndi Lauper's Settings">
		</td></tr>
		<tr><td align="center" colspan="9"><BR><HR>
		<b>Don't bother changing the fields below. They're just an example of how to use &lt;esc&gt; tags.</b><BR><BR>
		You should escape text in your fields like so:<BR>
		<textarea name="nothing" cols="40" rows="5"><b>Not escaped.</b>\n<esc>\n<i>"Escaped",\n& Running Free.</i>\n</esc></textarea><BR><BR>
		The end result will look like this:<BR>
		<textarea name="nothing" cols="40" rows="5"><b>Not escaped.</b>\n<esc>\n&amp;lt;i&amp;gt;&amp;quot;Escaped&amp;quot;,\n&amp;amp; Running Free.&amp;lt;/i&amp;gt;\n</esc></textarea><BR><BR>
		</td></tr>
		</table>
		</form>~;
	}
	&NPHTMLFoot;
	exit;
}
1;
